unit uHigh;

interface

uses sysutils, classes;

type

mystr=string[20];

tEintrag=class
private
  punkte:integer;
  spieler:mystr;
public
 procedure set_punkte(p:integer);
 function get_punkte:integer;
 procedure set_name(n:mystr);
 function get_name:string;
end;

tHighscore=class
private
 liste:array of tEintrag;
 voll:boolean;
public
 constructor create;
 procedure dazu(p:integer;s:string);
 procedure sortieren;
 function ausgeben:string;
 procedure speichern(pfad:string);
 procedure laden(pfad:string);
end;

implementation

//*********TEintrag*********************

procedure TEintrag.set_punkte(p: Integer);
begin
  punkte:=p;
end;

function TEintrag.get_punkte:integer;
begin
  result:=punkte;
end;

procedure TEintrag.set_name(n: mystr);
begin
  spieler:=n;
end;

function tEintrag.get_name:string;
begin
  result:=spieler;
end;

//***********THighscore********************

constructor Thighscore.create;
begin
 inherited;
 setlength(liste,0);
 voll:=false;
end;

procedure Thighscore.dazu(p:integer;s:string);
var n,i:integer;
begin
n:=length(liste);
if n>=10 then voll:=true;
if not voll then
   begin
     setlength(liste,n+1);
     liste[n]:=TEintrag.Create;
     liste[n].punkte:=p;
     liste[n].spieler:=s;
   end
else
   begin
     for i:=0 to high(liste) do
     if p>liste[i].punkte then
      begin
        liste[i].punkte:=p;
        liste[i].spieler:=s;
        break;
      end;
   end;
 sortieren;
end;

procedure Thighscore.sortieren;
var p,i:integer;
    buf:TEintrag;
begin
for p:=high(liste)-1 downto 1 do
for i:=0 to p do
  if liste[i].punkte>liste[i+1].punkte then
   begin
    buf:=liste[i];
    liste[i]:=liste[i+1];
    liste[i+1]:=buf;
   end;
end;

function Thighscore.ausgeben:string;
var i,n:integer;
begin
n:=0;
result:='********HALL OF FAME*********'+#13#10;
for i := high(liste) downto 0 do
  begin
   inc(n);
   result:=result+'Platz '+inttostr(n)+': '+liste[i].spieler+' : '+inttostr(liste[i].punkte)+#13#10;
  end;
end;

procedure THighscore.speichern(pfad:string);
var
  i: integer;
  fs:Tfilestream;
begin
  fs:=Tfilestream.create(pfad, fmcreate);
  try
    for i := 0 to High(liste) do
    begin
      fs.Write(liste[i].spieler, SizeOf(mystr));
      fs.Write(liste[i].punkte, SizeOf(integer));
    end;
  finally
    fs.Free;
  end;
end;


procedure Thighscore.laden(pfad: string);
var fs: TFileStream;
    i: Integer;
begin
  fs := TFilestream.Create(pfad, fmOpenRead);
  try
  SetLength(liste, FS.Size div (SizeOf(mystr)+sizeof(integer)));
    for i:=0 to high(liste) do
    begin
      liste[i]:=TEintrag.Create;
      fs.Read(liste[i].spieler, SizeOf(mystr));
      fs.Read(liste[i].punkte, SizeOf(integer));
    end;
  finally
    fs.free ;
  end;
end;


end.
